/* +=======================================================+ */
/* | SokoWABan - A CODEF 4K Sokoban clone                  | */
/* +-------------------------------------------------------+ */
/* | A CODEF submission for the WAB Contest #1             | */
/* | Released on june 30 2016                              | */
/* | Credits :                                             | */
/* |   - Code  : Dyno                                      | */
/* |   - Music : Tiny Skweeks by Moby                      | */
/* | More info on https://www.facebook.com/groups/codef/   | */
/* +-------------------------------------------------------+ */
/* | Copyleft 2016 by Dyno <dyno@aldabase.com>             | */
/* +=======================================================+ */

// ==ClosureCompiler==
// http://closure-compiler.appspot.com/home
// @compilation_level ADVANCED_OPTIMIZATIONS
// @output_file_name index.js
// @output_format text
// @output_info compiled_code
// @externs_url http://live.aldabase.com/2016/wab-contest-os/closure/codef_core.js
// @externs_url http://live.aldabase.com/2016/wab-contest-os/closure/codef_music.js
// ==/ClosureCompiler==

// Declared functions
var game_controller,
    game_init_level,
    game_display_map,
    game_direction,
    game_next_level,
    main_init_canvas,
    main_number_format,
    map_check_end_of_game,
    map_is_box,
    map_is_empty,
    map_is_destination,
    modal_view,
    sprite_draw,
    sprite_direction,
    sprite_move,
    sprite_push_or_pull,
    statusbar_game,
    unpack_levels;

// Global variables
var current_level = 0,
    allow_move = 1,
    current_move,
    current_push,
    canvas_w = 25,
    canvas_h = 18,
    sprite_w = 32,
    sprite_h = 32,
    shadow_w = 8,
    displayzone,
    displaygnd,
    displaysha,
    displaymap,
    displayobj,
    pos_x,
    pos_y,
    map,
    map_width,
    map_height,
    map_obj,
    doc,
    doc_main,
    tmp,
    // Pictures
    picture = [];

var levels_length = 20,
    levels = [
        "cjAc393Ac393A4b97w43l3wb1317138n393171j5633V63j1b1317563c3hzcrs|jb8527354742757",                          // Thinking_Rabbit #1
        "8bg47130f075b537t33l353b5b5343536530717231703l7003h740r8|b44335445",                                       // Sasquatch #1
        "070j7171213317521307h37db3d74361707393070j034|94452433425",                                                // Sasquatch #2
        "Aj0A793A3d3cf4397c35f930c3x308717l3083523l3083523l30j1z03ed3k3ed3k75nk0fE|g6ac3b4d4a5c596b6d6a7c7",        // Sasquatch #3
        "r3h33525336363352533h3r|732224223432444",                                                                  // Puzzle #4
        "L43653hb3653p336531f5336l753365313d7n17d343B343d3h34L|e7472a263a596b6477797b7",                            // Thinking_Rabbit #2
        "4H07h393bh393317t3353d393n1n361653270316db4356j8zc|db14262724393a3646696",                                 // Sasquatch #4
        "En4cf47d344b5343571bbdf13h33lmh33l71b9bb1b931j403lbs039fA0jM|j54g334a4f42545",                             // Sasquatch #7
        "cr4c3h70j1b573p35735e1753353d71237575393075f212347t38n57sf0|d1424344454a4a6a7",                            // Sasquatch #8
        "n0353273d233h335363r|71422324233",                                                                         // Puzzle #3
        "sv0s3l30s353570s3h34s7d34z931b3e57p37aF33e5Dvw|he1a2c2a3d3a4c4a5a6d697c7",                                 // Thinking_Rabbit #3
        "z3212d33212125371b5303h703d7003d34035b40fc|9632244354546",                                                 // Sasquatch #9
        "4fgb5f43p7031321232b3x3b2323231307p34f5bgf4|b42243444647484",                                              // Sasquatch #11
        "0r47h303356123435632b313l33971313n93gj|a44325233345464",                                                   // Sasquatch #14
        "0r71321233d21335321233d213713573d7039743578fc|818322353344526",                                            // Puzzle #1
        "n4b036530717365b9336t33653139336b1393f939383939383p38357938z|c9183939495568667975888",                     // Thinking_Rabbit #6
        "cfj533l33l33m33m33l33m33m33l33l33l33l335jfc|81d1333532444641535552646662848681939592a4a6a1b3b5b",          // Sasquatch #18
        "gfg353n1233l233da33d673d630v0|934624363244425354536",                                                      // Sasquatch #20
        "j0v039b12d303ha13577531ah303d21b930v0j|fd3a14262b23383a344",                                               // Sasquatch #21
        "gjcg39788bd74839397083h357n1317533653p336lj365jcns|e18627254769657",                                       // Puzzle #2
    ];

function getHex(pos) {
    return '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWX@&%#+-*/=$|~.,:;!?^_()[]<>{}'.indexOf(pos);
}

function getCanvas(height) {
    var local = mechanizedAbbreviation(new canvas(canvas_w * sprite_w, height)),
        style = local.cs.style;
    doc_main.appendChild(local.cs);
    style.position = 'absolute';
    style.top = 0;
    style.left = 0;
    return local;
}

//=========================
// mechanized abbreviation
//=========================
// see http://marijnhaverbeke.nl/js1k/

function mechanizedAbbreviation(object) {
    for (tmp in object) {
        object[tmp[0] + (tmp[5]||'')] = object[tmp];
    }
    return object;
}

//==================
// main_init_canvas
//==================

main_init_canvas = function (create) {

    if (create) {

        doc_main.setAttribute('style', 'width:' + (canvas_w * sprite_w) + 'px;height:' + (canvas_h * sprite_h + 24) + 'px;position:relative;');
    
        // Screen zone
        displayzone = getCanvas(canvas_h * sprite_h + 24);
        // Ground
        displaygnd = getCanvas(canvas_h * sprite_h);
        // Shadows
        displaysha = getCanvas(canvas_h * sprite_h);
        // Map
        displaymap = getCanvas(canvas_h * sprite_h);
        // Objects
        displayobj = getCanvas(canvas_h * sprite_h);

    } else {
        picture[2].d(displayzone, 0, 0);
        displaygnd.c();
        displaysha.c();
        displaymap.c();
        displayobj.c();
    }

};

//====================
// main_number_format
//====================

main_number_format = function (number, length) {
    return ('000' + number).slice(-length);
};

//=================
// game_controller
//=================

game_controller = function (add) {

    current_move = 0;
    current_push = 0;
    current_level += add;

    if (current_level < 1) {
        current_level = 1;
    }
    if (current_level > levels_length) {
        current_level = levels_length;
    }

    game_init_level(levels[current_level - 1]);
    main_init_canvas(0);

    game_display_map();
    statusbar_game();

};

//=================
// game_init_level
//=================

game_init_level = function (levelData) {

    var i, j, box;

    map = levelData.m;
    map_width = levelData.w;
    map_height = levelData.h;

    map_obj = [];
    for (j = 0; j < map_height; j++) {
        map_obj[j] = [];
        for (i = 0; i < map_width; i++) {
            map_obj[j][i] = 0;
        }
    }

    box = levelData.b;
    for (i = 0; i < box.length; i++) {
        map_obj[box[i][1]][box[i][0]] = 1;
    }

    pos_x = levelData.p[0];
    pos_y = levelData.p[1];

};

//=================
// game_next_level
//=================

game_next_level = function () {

    if (current_level == levels_length) {
        current_level = 0;
        game_controller(0);
    } else {
        game_controller(1);
    }

};

//==================
// game_display_map
//==================

game_display_map = function (/* var */ i, j, elt) {
    for (j = 0; j < map_height; j++) {
        for (i = 0; i < map_width; i++) {
            elt = map[j][i];
            // Ground
            if (elt == 1 || elt == 2) {
                sprite_draw(displaygnd, elt, i, j);
            // Walls
            } else if (elt == 3) {
                sprite_draw(displaymap, elt, i, j);
            }
            // Boxes
            if (map_obj[j][i] == 1) {
                if (map_is_destination(i, j)) {
                    sprite_draw(displayobj, 5, i, j);
                } else {
                    sprite_draw(displayobj, 4, i, j);
                }
            }
        }
    }
    // display character
    sprite_draw(displayobj, 6, pos_x, pos_y);
};

//================
// game_direction
//================

game_direction = function (dx, dy) {
    // Move sprite
    sprite_direction(dx, dy);
    // Check end of game
    if (map_check_end_of_game()) {
        modal_view();
    }
};

//=======================
// map_check_end_of_game
//=======================

map_check_end_of_game = function (/* var */ x, y) {
    for (y = 0; y < map_height; y++) {
        for (x = 0; x < map_width ; x++) {
            if (map_is_box(x, y) && (!map_is_destination(x, y))) {
                return false;
            }
        }
    }
    return true;
};

//============
// map_is_box
//============

map_is_box = function (x, y) {
    return (map_obj[y][x] == 1);
};

//==============
// map_is_empty
//==============

map_is_empty = function (x, y) {
    return (
        // Vide ou destination
        (map[y][x] == 1 || map_is_destination(x, y))
        // Pas de boite
        && (!map_is_box(x, y))
    );
};

//====================
// map_is_destination
//====================

map_is_destination = function (x, y) {
    return (map[y][x] == 2);
};

//=============
// sprite_draw
//=============
    
sprite_draw = function (layer, num, x, y) {
    var decal_x = (sprite_w / 2) * (canvas_w - map_width),
        decal_y = (sprite_h / 2) * (canvas_h - map_height),
        dest_x = decal_x + (x * sprite_w),
        dest_y = decal_y + (y * sprite_h);
    if (num == 0) {
        layer.cx.clearRect(dest_x, dest_y, sprite_w, sprite_h);
        displaysha.cx.clearRect(dest_x + shadow_w, dest_y + shadow_w, sprite_w, sprite_h);
    } else {
        num--;
        picture[1].da(
            layer,
            dest_x,
            dest_y,
            (num % 3) * sprite_w,
            ((num / 3)|0) * sprite_h,
            sprite_w,
            sprite_h
        );
        // Wall or Box : Drop shadow
        if (2 <= num && num <= 4) {
            displaysha.q(dest_x + shadow_w, dest_y + shadow_w, sprite_w, sprite_h, 'rgba(0,0,0,0.3)');
        }
    }
};

//==================
// sprite_direction
//==================

sprite_direction = function (dx, dy) {
    if (map_is_empty(pos_x + dx, pos_y + dy)) {
        sprite_move(dx, dy);
    } else if (map_is_box(pos_x + dx, pos_y + dy) && map_is_empty(pos_x + 2 * dx, pos_y + 2 * dy)) {
        sprite_push_or_pull(+1, dx, dy);
    }
};

//=============
// sprite_move
//=============

sprite_move = function (dx, dy) {
    // Remove character at current position
    sprite_draw(displayobj, 0, pos_x, pos_y);
    // Update position
    pos_x += dx;
    pos_y += dy;
    // Display at new position
    sprite_draw(displayobj, 6, pos_x, pos_y);
    // Inc move counter
    current_move++;
    // Refresh status bar
    statusbar_game();
};

//=====================
// sprite_push_or_pull
//=====================

sprite_push_or_pull = function (type, dx, dy) {
    var mult;
    // Update position (PULL)
    if (type == -1) {
        sprite_move(-dx, -dy);
    }
    // Remove box at old position
    mult = (type == 1) ? 1 : 2;
    sprite_draw(displayobj, 0, pos_x + mult * dx, pos_y + mult * dy);
    map_obj[pos_y + mult * dy][pos_x + mult * dx] = 0;
    // Display at new position
    mult = (type == 1) ? 2 : 1;
    if (map_is_destination(pos_x + mult * dx, pos_y + mult * dy)) {
        sprite_draw(displayobj, 5, pos_x + mult * dx, pos_y + mult * dy);
    } else {
        sprite_draw(displayobj, 4, pos_x + mult * dx, pos_y + mult * dy);
    }
    map_obj[pos_y + mult * dy][pos_x + mult * dx] = 1;
    // Update position (PUSH)
    if (type == 1) {
        sprite_move(dx, dy);
    }
    // Inc push counter
    current_push++;
    // Refresh status bar
    statusbar_game();
};

//================
// statusbar_game
//================

statusbar_game = function () {

    displayzone.q(0, 577, canvas_w * sprite_w, 23, '#000');

    picture[3].p(
        displayzone,
        'Level ' + main_number_format(current_level, 2) + ' / ' + main_number_format(levels_length, 2) +
            '    Moves ' + main_number_format(current_move, 4) +
            '    Pushes ' + main_number_format(current_push, 4) +
            '    (R)estart (N)ext',
        152,
        582
    );

};

//===============
// unpack_levels
//===============

unpack_levels = function () {

    var packed_map, packed_pos, idx, str,
        map, width, box, perso,
        i, j, k, l, m, pos, nb, val;

    for (k = 0; k < levels_length; k++) {

        idx = levels[k].indexOf('|');

        // Packed strings
        packed_map = levels[k].slice(0, idx);
        packed_pos = levels[k].slice(idx + 1);

        // Unpack map width
        width = getHex(packed_pos[0]);

        // Unpack character position
        perso = [getHex(packed_pos[1]), getHex(packed_pos[2])];

        // Unpack boxes position
        box = [];
        m = 0;
        str = packed_pos.slice(3);
        for (l = 0; l < str.length; l += 2) {
            i = getHex(str[l]);
            j = getHex(str[l + 1]);
            box[m++] = [i, j];
        }

        // Unpack map
        map = [];
        map[0] = [];
        i = 0;
        j = 0;
        for (l = 0; l < packed_map.length; l++) {
            pos = getHex(packed_map[l]);
            nb = (pos / 4) | 0;
            val = pos - nb * 4;
            for (m = 0; m <= nb ; m++) {
                map[j][i++] = val;
                if (i >= width) {
                    i = 0;
                    j++;
                    map[j] = [];
                }
            }
        }

        // Create unpacked version of map object
        levels[k] = {
            w: width,
            h: j,
            m: map,
            b: box,
            p: perso
        };

    }

};

//============
// modal_view
//============

modal_view = function () {

    displayobj.q(240, 230, canvas_w * sprite_w - 480, canvas_h * sprite_h - 460, '#000');

    picture[3].p(displayobj, "LEVEL " + main_number_format(current_level, 2) + " COMPLETE", 332, 260);
    picture[3].p(displayobj, "Press N", 372, 300);

    allow_move = 0;

};

//===============
// main function
//===============

function init() {

    doc = document;
    doc_main = doc.getElementById("main");
    
    // Load images
    for (i = 0 ; i < 4 ; i++) {
        picture[i] = mechanizedAbbreviation(new image(i + '.png'));
    }

    picture[0].i.onload = function() {
        picture[0].d(displayzone, 0, 0);
    }

    picture[3].ii(8, 14, 32);
    
    mechanizedAbbreviation(new music()).Ln('c.mod');

    unpack_levels();

    doc.onkeydown = function(event) {
        var key = event.which || event.keyCode;
        if (allow_move && key == 40) {          // Down
            game_direction(0, 1);
        } else if (allow_move && key == 38) {   // Up
            game_direction(0, -1);
        } else if (allow_move && key == 37) {   // Left
            game_direction(-1, 0);
        } else if (allow_move && key == 39) {   // Right
            game_direction(1, 0);
        } else if (key == 78) {                 // (N)ext
            allow_move = 1;
            game_next_level();
        } else if (key == 82) {                 // (R)estart
            allow_move = 1;
            game_controller(0);
        }
    };

    main_init_canvas(1);

};

// CLOSURE COMPILER
window['init'] = init;
