<?php

$fn = __DIR__ . '/../index.js'; // original JS
$js = '';		                // code to compress
$jscomp = '';	                // compressed JS
$reduced = -1;	                // compression saving

// Fetch JavaScript file
$js = file_get_contents($fn);

// REST API arguments
$args = 'js_code=' . urlencode($js);
foreach (file($fn) AS $line) {
    if (preg_match('|^//\s+@([a-z_]+)\s+(.*)$|', $line, $matches)) {
        if ($matches[1] != 'output_file_name') {
            $args .= '&' . $matches[1] . '=' . urlencode($matches[2]);
        }
    }
}

// API call using cURL
$call = curl_init();
curl_setopt_array(
    $call,
    array(
        CURLOPT_URL => 'http://closure-compiler.appspot.com/compile',
        CURLOPT_POST => 1,
        CURLOPT_POSTFIELDS => $args,
        CURLOPT_RETURNTRANSFER => 1,
        CURLOPT_HEADER => 0,
        CURLOPT_FOLLOWLOCATION => 0
    )
);
$jscomp = curl_exec($call);
curl_close($call);

// Post-process
$jscomp = str_replace("\r", '', $jscomp);
$jscomp = str_replace("\n", '', $jscomp);
$jscomp = str_replace('window.init=function()', 'function init()', $jscomp);
$jscomp = preg_replace('#window\.([a-z0-9]+)=[a-z]+;#i', '', $jscomp);

// Compress first "var" statement
if (preg_match('#^var\s+([^;]+);(.*)#', $jscomp, $matches)) {

    $var_statement = $matches[1];
    
    // Delete empty variable declaration
    $var_statement = preg_replace('/,([a-z]*)(?=,)/i', '', $var_statement);
    $var_statement = preg_replace('/^([a-z]*),/i', '', $var_statement);

    // Replace compressed JS content
    $jscomp = 'var ' . trim($var_statement, ',') . ';' . $matches[2];

}

// Save compressed content
file_put_contents(__DIR__ . '/../index.min.js', $jscomp);

// Calculate compression saving
$reduced = (strlen($js) - strlen($jscomp)) / strlen($js) * 100;
// Output saving
if ($reduced >= 0) {
	echo
        'Original file : ' . strlen($js) . ' bytes' . PHP_EOL .
        'Compressed file : ' . strlen($jscomp) . ' bytes' . PHP_EOL .
        'Ratio : ', round($reduced, 1), '%.' . PHP_EOL;
}

?>